import RPi.GPIO as GPIO
import time

from subprocess import call

# Use board numbering scheme
GPIO.setmode(GPIO.BOARD)

# Pin location definitions
one_pence_pin = 8
two_pence_pin = 10
five_pence_pin = 12
ten_pence_pin = 16
twenty_pence_pin = 18
fifty_pence_pin = 22
one_pound_pin = 24
two_pound_pin = 26

# Configure I/O pins
GPIO.setup(one_pence_pin, GPIO.IN, pull_up_down=GPIO.PUD_DOWN)
GPIO.setup(two_pence_pin, GPIO.IN, pull_up_down=GPIO.PUD_DOWN)
GPIO.setup(five_pence_pin, GPIO.IN, pull_up_down=GPIO.PUD_DOWN)
GPIO.setup(ten_pence_pin, GPIO.IN, pull_up_down=GPIO.PUD_DOWN)
GPIO.setup(twenty_pence_pin, GPIO.IN, pull_up_down=GPIO.PUD_DOWN)
GPIO.setup(fifty_pence_pin, GPIO.IN, pull_up_down=GPIO.PUD_DOWN)
GPIO.setup(one_pound_pin, GPIO.IN, pull_up_down=GPIO.PUD_DOWN)
GPIO.setup(two_pound_pin, GPIO.IN, pull_up_down=GPIO.PUD_DOWN)

# Variables
timerValue = 0
rollingCount = 0
totalValue = 0
coinTimeout = (0.01 * 100) * 5


while True:
    
    if(GPIO.input(one_pence_pin) == 0):
        print("1p Detected")
        time.sleep(0.5)
        rollingCount = rollingCount + 0.01
        timerValue = 0

    if(GPIO.input(two_pence_pin) == 0):
        print("2p Detected")
        time.sleep(0.5)
        rollingCount = rollingCount + 0.02
        timerValue = 0
        
    if(GPIO.input(five_pence_pin) == 0):
        print("5p Detected")
        time.sleep(0.5)
        rollingCount = rollingCount + 0.05
        timerValue = 0
        
    if(GPIO.input(ten_pence_pin) == 0):
        print("10p Detected")
        time.sleep(0.5)
        rollingCount = rollingCount + 0.10
        timerValue = 0

    if(GPIO.input(twenty_pence_pin) == 0):
        print("20p Detected")
        time.sleep(0.5)
        rollingCount = rollingCount + 0.20
        timerValue = 0

    if(GPIO.input(fifty_pence_pin) == 1):
        print("50p Detected")
        time.sleep(0.5)
        rollingCount = rollingCount + 0.50
        timerValue = 0
        
    if(GPIO.input(one_pound_pin) == 0):
        print("1 Pound Detected")
        time.sleep(0.5)
        rollingCount = rollingCount + 1
        timerValue = 0
        
    if(GPIO.input(two_pound_pin) == 0):
        print("2 Pound Detected")
        time.sleep(0.5)
        rollingCount = rollingCount + 2
        timerValue = 0

    rollingCount = round(rollingCount, 2)

    # Determine if its time to add the rolling count to the total
    if(timerValue > 400):
        if(rollingCount > 0):
            timerValue
            totalValue = round(totalValue + rollingCount, 2)
            print("Total Value:" + str(totalValue))
            rollingCount = round(rollingCount * 100, 0)
            totalValueAdjusted = round(totalValue * 100, 0)
            call("espeak " + "'You deposited " + str(rollingCount) + " pennies'", shell=True)
            call("espeak " + "'You have saved " + str(totalValueAdjusted) + " pennies'", shell=True)

            # Insults based on how much was deposited
            
            if(rollingCount < 5):
                call("espeak " + "'congratulations, if you continue like this you will have enough by the end of summer for a small tin of beans. From pound land'", shell=True)

            if((rollingCount >= 5) and (rollingCount < 20)):
                call("espeak " + "'Dont be proud of yourself because you saved less than 20 pence. Seriously. You should be ashamed of yourself!'", shell=True)

            if((rollingCount >= 20) and (rollingCount < 100)):
                call("espeak " + "'Picture your summer holiday. Now picture it in your back garden. Now picture yourself broke. That will be your holiday at this rate!'", shell=True)

            if((rollingCount >= 100) and (rollingCount < 500)):
                call("espeak " + "'What does this savings bank and an onion both have in common? When opened, they both make you cry!'", shell=True)

            if((rollingCount >= 500) and (rollingCount < 1000)):
                call("espeak " + "'How long did it take you to save that? I ask because that is enough to get you one drink from most places in Europe. Just saying.'", shell=True)

            # Prase if the user deserves it
            if((totalValueAdjusted < 100)):
                call("espeak " + "'Oh and by the way, you still cannot afford anything from pound land. And that is saying a lot'", shell=True)

            if((totalValueAdjusted >= 100) and (totalValueAdjusted < 1000)):
                call("espeak " + "'One other thing, I just checked your total savings, it is not good'", shell=True)

            if((totalValueAdjusted >= 1000) and (totalValueAdjusted < 5000)):
                call("espeak " + "'You have not really saved a lot of money, you may want to think about preparing yourself for a garden holiday'", shell=True)
            
            rollingCount = 0
    timerValue = timerValue + 1
    time.sleep(0.01)

GPIO.cleanup()
